/**************************************************************

chartexportdlg.h (C-Munipack project)
Export chart dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_CHARTEXPORT_DLG_H
#define CMPACK_CHARTEXPORT_DLG_H

#include <gtk/gtk.h>

#include "image_size.h"

class CChartExportDlg
{
public:
	// Constructor
	CChartExportDlg(GtkWindow *pParent);

	// Destructor
	virtual ~CChartExportDlg();

	// Execute the dialog
	bool Execute(CmpackChartData *chart, CmpackImageData *image);

private:
	GtkWindow			*m_Parent;
	GtkWidget			*m_pDlg;
	CImageSizeWidget	m_Widget;
	int					m_DstWidth, m_DstHeight;
	int					m_JpegQuality;
	const gchar			*m_DstFormat;
	gchar				*m_FilePath;
	CmpackChartData		*m_ChartData;
	CmpackImageData		*m_ImageData;
	
	bool OnResponseDialog(gint response_id);
	void OnTypeChanged(void);
	bool CheckFormat(void);
	int  OnExport(CProgressDlg *sender);

	static void response_dialog(GtkWidget *widget, gint response_id, CChartExportDlg *pMe);
	static void WidgetCallback(CCBObject *sender, int message, int wparam, void* lparam, void* cb_data);
	static int ExportProc(CProgressDlg *sender, void *user_data);
};

class CGraphExportDlg
{
public:
	// Constructor
	CGraphExportDlg(GtkWindow *pParent);

	// Destructor
	virtual ~CGraphExportDlg();

	// Execute the dialog
	bool Execute(CmpackGraphView *widget);

private:
	GtkWidget			*m_pDlg;
	CGraphSizeWidget	m_Widget;
	int					m_JpegQuality;
	const gchar			*m_DstFormat;
	gchar				*m_FilePath;
	CmpackGraphView		*m_Graph;
	
	bool OnResponseDialog(gint response_id);
	void OnTypeChanged(void);
	bool CheckFormat(void);

	static void response_dialog(GtkWidget *widget, gint response_id, CGraphExportDlg *pMe);
	static void WidgetCallback(CCBObject *sender, int message, int wparam, void* lparam, void* cb_data);
};

#endif
