/**************************************************************

profile.h (C-Munipack project)
"Load Profile" dialog
Copyright (C) 2012 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef MUNIWIN_LOAD_PROFILE_DLG_H
#define MUNIWIN_LOAD_PROFILE_DLG_H

#include <gtk/gtk.h>

#include "profile.h"

//
// New project dialog (initial project settings)
//
class CLoadProfileDlg
{
public:
	CLoadProfileDlg(GtkWindow *pParent, tProjectType type, bool no_default);
	~CLoadProfileDlg();

	bool Execute(CProfile &profile);

private:
	enum tSelectMode {
		PROFILE, PROJECT, DEFAULTS
	};

	CProfile		m_Profile;
	tProjectType	m_Type;
	GtkWidget		*m_pDlg, *m_ProfileBtn, *m_ProjectBtn, *m_DefaultsBtn;
	GtkWidget		*m_SrcLabel, *m_SrcEntry, *m_BrowseBtn, *m_FileBox;
	GtkWidget		*m_ListBox, *m_PathEntry, *m_PathBtn, *m_SearchBox;
	GtkWidget		*m_TreeView, *m_OptionsBox, *m_RecentList;
	GtkListStore	*m_FileList;
	tSelectMode		m_SelectMode;
	bool			m_Updating;

	void SetSelectMode(tSelectMode mode);
	void BrowseForFile(void);
	void ChangeSearchPath(void);
	void UpdateProfiles(void);
	void UpdateProjects(void);

	bool OnResponseDialog(gint response_id);
	bool OnCloseQuery(void);
	void OnButtonClicked(GtkWidget *pBtn);
	void OnSelectionChanged(GtkTreeSelection *selection);
	void OnSelectionChanged(GtkRecentChooser *widget);
	gboolean OnRecentFilter(const GtkRecentFilterInfo *filter_info);

	static void response_dialog(GtkWidget *widget, gint response_id, CLoadProfileDlg *pMe);
	static void button_clicked(GtkWidget *pButton, CLoadProfileDlg *pDlg);
	static void tv_selection_changed(GtkTreeSelection *pWidget, CLoadProfileDlg *pMe);
	static void rc_selection_changed(GtkRecentChooser *pWidget, CLoadProfileDlg *pMe);
	static gboolean recent_filter(const GtkRecentFilterInfo *filter_info, CLoadProfileDlg *pMe);
};

#endif
