/**************************************************************

profile.h (C-Munipack project)
"Load Profile" dialog
Copyright (C) 2012 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef MUNIWIN_NEW_PROJECT_H
#define MUNIWIN_NEW_PROJECT_H

#include <gtk/gtk.h>

#include "profile.h"

//
// New project dialog (name, path & type)
//
class CNewProjectDlg
{
public:
	CNewProjectDlg(GtkWindow *pParent, bool import);
	~CNewProjectDlg();

	// Execute the dialog
	bool Execute(void);
	const gchar *FilePath(void) const { return m_FilePath; }
	tProjectType Type(void) const { return m_Type; }

private:
	GtkWidget		*m_pDlg, *m_TypeView;
	GtkWidget		*m_Name, *m_Path, *m_PathBtn;
	GtkListStore	*m_Types;
	tProjectType	m_Type;
	gchar			*m_ParentDir, *m_FilePath;
	bool			m_Import;

	bool OnCloseQuery(void);
	bool OnResponseDialog(gint response_id);
	void OnButtonClicked(GtkWidget *widget);
	void ChangeDirPath(void);
	
	static void response_dialog(GtkDialog *pDlg, gint response_id, CNewProjectDlg *pMe);
	static void button_clicked(GtkWidget *widget, CNewProjectDlg *pMe);
};

#endif
